# Derived from GitLab Docker template
# Official docker image.
image: docker:latest

services:
  - docker:dind

before_script:
  - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  - ./generate-dockerfile.sh

variables:
  IMAGE: "$CI_REGISTRY_IMAGE"
  TAG: "git-$CI_COMMIT_SHA"
  BTAG: "$CI_COMMIT_REF_SLUG"

.build-template: &build
  stage: build
  script:
    - docker build --pull -t "$IMAGE:$TAG-$ARCH" . -f "Dockerfile.$DOCKERFILE_SUFFIX"
    - docker push "$IMAGE:$TAG-$ARCH"
    - docker tag "$IMAGE:$TAG-$ARCH" "$IMAGE:$BTAG-$ARCH"
    - docker push "$IMAGE:$BTAG-$ARCH"

build-amd64:
  <<: *build
  variables:
    ARCH: amd64
    DOCKERFILE_SUFFIX: amd64

build-armv7hf:
  <<: *build
  variables:
    ARCH: armv7hf
    DOCKERFILE_SUFFIX: armv7hf-xbuild
